// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'ColMemo.pas' rev: 3.00

#ifndef ColMemoHPP
#define ColMemoHPP
#include <Forms.hpp>
#include <StdCtrls.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <SysUtils.hpp>
#include <Graphics.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Colmemo
{
//-- type declarations -------------------------------------------------------
struct TKeyDescr;
typedef TKeyDescr *PKeyDescr;

struct TKeyDescr
{
	int Left;
	int Right;
	Graphics::TColor KeyColor;
	Byte ZOrder;
	bool DrawKey;
} ;

typedef TKeyDescr AKeyDescr[8001];

struct TBeginEndDescr
{
	char CBegin[7];
	char CEnd[7];
	Graphics::TColor KeyColor;
	char *Pos;
} ;

typedef TBeginEndDescr ABeginEndDescr[101];

typedef void __fastcall (__closure *TNotifyEvent)(System::TObject* Sender);

typedef void __fastcall (__closure *THotSpotClickEvent)(System::TObject* Sender, const System::AnsiString 
	SRC);

typedef void __fastcall (__closure *TDrawEvent)(System::TObject* Sender, char * FromPos, TKeyDescr * 
	A, const int A_Size, int &ItemsCount);

typedef void __fastcall (__closure *TKeyDrawEvent)(Graphics::TCanvas* Canvas, const System::AnsiString 
	PKey, const Windows::TRect &Rect, Graphics::TColor KColor);

enum TKeyDrawingType { dtKeyShow, dtEventDraw, dtBeginEnd, dtBeginLineEnd };

class DELPHICLASS TKeyDescrList;
class PASCALIMPLEMENTATION TKeyDescrList : public Classes::TList 
{
	typedef Classes::TList inherited;
	
public:
	__fastcall virtual ~TKeyDescrList(void);
public:
	/* TObject.Create */ __fastcall TKeyDescrList(void) : Classes::TList() { }
	
};

class DELPHICLASS TColorRule;
class DELPHICLASS TColorMemo;
class DELPHICLASS TDrawRules;
typedef System::TMetaClass*TColorRuleClass;

class PASCALIMPLEMENTATION TDrawRules : public Classes::TCollection 
{
	typedef Classes::TCollection inherited;
	
private:
	TColorMemo* FColorMemo;
	bool FRUpdate;
	TColorRule* __fastcall GetRule(int Index);
	void __fastcall SetRule(int Index, TColorRule* Value);
	void __fastcall UpdRules(void);
	
public:
	__fastcall TDrawRules(TColorMemo* CLMM, System::TMetaClass* RuleClass);
	HIDESBASE TColorRule* __fastcall Add(void);
	__property TColorMemo* CMemo = {read=FColorMemo};
	__property bool UpdateRules = {read=FRUpdate, write=FRUpdate, nodefault};
	__property TColorRule* Items[int Index] = {read=GetRule, write=SetRule/*, default*/};
public:
	/* TCollection.Destroy */ __fastcall virtual ~TDrawRules(void) { }
	
};

class DELPHICLASS THotSpot;
class PASCALIMPLEMENTATION THotSpot : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	char FHSBegChar;
	char FHSEndChar;
	Graphics::TColor FHotSpotColor;
	Graphics::TColor FHotSpotMarkerColor;
	bool FHotSpotActive;
	bool FHotSpotUnderlined;
	
public:
	__fastcall THotSpot(void);
	HIDESBASE void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property char BeginChar = {read=FHSBegChar, write=FHSBegChar, default=30};
	__property char EndChar = {read=FHSEndChar, write=FHSEndChar, default=31};
	__property Graphics::TColor Color = {read=FHotSpotColor, write=FHotSpotColor, default=16711680};
	__property Graphics::TColor MarkerColor = {read=FHotSpotMarkerColor, write=FHotSpotMarkerColor, default=-2147483643
		};
	__property bool Active = {read=FHotSpotActive, write=FHotSpotActive, default=0};
	__property bool Underlined = {read=FHotSpotUnderlined, write=FHotSpotUnderlined, default=1};
public:
		
	/* TPersistent.Destroy */ __fastcall virtual ~THotSpot(void) { }
	
};

class PASCALIMPLEMENTATION TColorMemo : public Stdctrls::TMemo 
{
	typedef Stdctrls::TMemo inherited;
	
private:
	Graphics::TCanvas* FCanvas;
	TDrawRules* FRules;
	int FColorLimMax;
	bool FFullRedraw;
	THotSpotClickEvent FOnHotSpotClick;
	TNotifyEvent FOnVScroll;
	TNotifyEvent FOnHScroll;
	TDrawEvent FOnDraw;
	TKeyDrawEvent FOnKeyDraw;
	THotSpot* FHotSpotProp;
	int CurLine;
	int CurPosn;
	int CurTop;
	int MaxLines;
	int MemLnCnt;
	int MemChCnt;
	bool VER95;
	AKeyDescr *CLR_LIM;
	void *CLAR;
	int CLAR_SIZ;
	TKeyDescrList* PR;
	char *AA;
	int AASize;
	char *AA1;
	int AA1Size;
	int MINLEFT;
	int MAXRIGHT;
	MESSAGE void __fastcall DoOnHScroll(Messages::TWMScroll &Msg);
	MESSAGE void __fastcall DoOnVScroll(Messages::TWMScroll &Msg);
	MESSAGE void __fastcall DoOnResize(Messages::TWMSize &Msg);
	int __fastcall GetCurrentLine(void);
	int __fastcall GetCurrentPosition(void);
	int __fastcall GetTopLine(void);
	void __fastcall SetCurrentLine(int Value);
	void __fastcall SetCurrentPosition(int Value);
	void __fastcall SetRules(TDrawRules* Value);
	void __fastcall SetHotSpotProp(THotSpot* Value);
	void __fastcall SetColorLimMax(int Value);
	int __fastcall GetLinesVisible(void);
	int __fastcall GetMaxLinesVisible(void);
	int __fastcall CalcTabs(int PIND, char * EBUF, char * PFrom, int PCount, TKeyDescrList* A);
	int __fastcall CalcHotSpots(int PIND, char * EBUF, char * PFrom, int PCount, TKeyDescrList* A);
	HIDESBASE MESSAGE void __fastcall WMPaint(Messages::TWMPaint &Message);
	
protected:
	virtual void __fastcall Paint(System::TObject* Sender, bool CurrLine);
	DYNAMIC void __fastcall Change(void);
	DYNAMIC void __fastcall KeyDown(Word &Key, Classes::TShiftState Shift);
	DYNAMIC void __fastcall KeyUp(Word &Key, Classes::TShiftState Shift);
	DYNAMIC void __fastcall MouseDown(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, 
		int Y);
	DYNAMIC void __fastcall MouseUp(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, int 
		Y);
	DYNAMIC void __fastcall MouseMove(Classes::TShiftState Shift, int X, int Y);
	virtual void __fastcall PaintWindow(HDC DC);
	__property Graphics::TCanvas* Canvas = {read=FCanvas};
	
public:
	__fastcall virtual TColorMemo(Classes::TComponent* AOwner);
	__fastcall virtual ~TColorMemo(void);
	__property int CurrentLine = {read=GetCurrentLine, write=SetCurrentLine, nodefault};
	__property int CurrentPosition = {read=GetCurrentPosition, write=SetCurrentPosition, nodefault};
	__property int TopLine = {read=GetTopLine, nodefault};
	__property int LinesVisible = {read=GetLinesVisible, nodefault};
	__property int MaxLinesVisible = {read=GetMaxLinesVisible, nodefault};
	HIDESBASE void __fastcall ScrollBy(int X, int Y);
	void __fastcall GetMaxLines(void);
	
__published:
	__property TNotifyEvent OnVScroll = {read=FOnVScroll, write=FOnVScroll};
	__property TNotifyEvent OnHScroll = {read=FOnHScroll, write=FOnHScroll};
	__property THotSpotClickEvent OnHotSpotClick = {read=FOnHotSpotClick, write=FOnHotSpotClick};
	__property TDrawEvent OnDraw = {read=FOnDraw, write=FOnDraw};
	__property TKeyDrawEvent OnDrawKey = {read=FOnKeyDraw, write=FOnKeyDraw};
	__property TDrawRules* ColorRules = {read=FRules, write=SetRules};
	__property int ColorLimMax = {read=FColorLimMax, write=SetColorLimMax, default=0};
	__property bool RedrawAlways = {read=FFullRedraw, write=FFullRedraw, default=0};
	__property THotSpot* HotSpot = {read=FHotSpotProp, write=SetHotSpotProp};
public:
	/* TWinControl.CreateParented */ __fastcall TColorMemo(HWND ParentWindow) : Stdctrls::TMemo(ParentWindow
		) { }
	
};

class PASCALIMPLEMENTATION TColorRule : public Classes::TCollectionItem 
{
	typedef Classes::TCollectionItem inherited;
	
private:
	TColorMemo* FColorMemo;
	TKeyDrawingType FRuleType;
	Classes::TStrings* FKeywords;
	Classes::TStrings* FKeyBegEnd;
	Classes::TStrings* FKeyLineEnd;
	bool FKeyCase;
	bool FEnabled;
	bool FPartWord;
	bool FWholeWord;
	Graphics::TColor FKeyDefColor;
	Graphics::TColor FKeySelColor;
	Graphics::TColor FKeyBrushColor;
	int FKeyMaxLines;
	Byte FZOrder;
	System::AnsiString FIntChar;
	int FMaxBegEndDscr;
	ABeginEndDescr *BegEnd;
	System::AnsiString KeywStr;
	char AAA[31];
	char *CaseBuf;
	int CaseBufLen;
	
protected:
	void __fastcall SetKeywords(Classes::TStrings* Value);
	void __fastcall SetKeyBegEnd(Classes::TStrings* Value);
	void __fastcall SetKeyLineEnd(Classes::TStrings* Value);
	void __fastcall SetKeyCase(bool Value);
	void __fastcall SetMaxDescr(int Value);
	
public:
	__fastcall virtual TColorRule(Classes::TCollection* Collection);
	__fastcall virtual ~TColorRule(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	int __fastcall CalcColors(int PIND, char * EBUF, char * PFrom, int PCount, TKeyDescrList* A);
	bool __fastcall UpdateKeyParams(void);
	__property TColorMemo* CMemo = {read=FColorMemo};
	__property int MaxBegEndDescr = {read=FMaxBegEndDscr, write=SetMaxDescr, default=0};
	
__published:
	__property Byte ZOrder = {read=FZOrder, write=FZOrder, default=0};
	__property System::AnsiString IntChar = {read=FIntChar, write=FIntChar};
	__property Classes::TStrings* Keywords = {read=FKeywords, write=SetKeywords};
	__property Classes::TStrings* KeyBegEndLst = {read=FKeyBegEnd, write=SetKeyBegEnd};
	__property Classes::TStrings* KeyLineEndLst = {read=FKeyLineEnd, write=SetKeyLineEnd};
	__property int KeyMaxHeight = {read=FKeyMaxLines, write=FKeyMaxLines, default=1};
	__property TKeyDrawingType KeyDrawingType = {read=FRuleType, write=FRuleType, default=2};
	__property bool KeyCase = {read=FKeyCase, write=SetKeyCase, default=0};
	__property bool Enabled = {read=FEnabled, write=FEnabled, default=1};
	__property bool PartWord = {read=FPartWord, write=FPartWord, default=0};
	__property Graphics::TColor DefKeyColor = {read=FKeyDefColor, write=FKeyDefColor, default=255};
	__property Graphics::TColor KeySelColor = {read=FKeySelColor, write=FKeySelColor, default=65535};
	__property Graphics::TColor KeyBrushColor = {read=FKeyBrushColor, write=FKeyBrushColor, default=-2147483643
		};
};

//-- var, const, procedure ---------------------------------------------------
#define BEG_END_CNT (Byte)(40)
#define BEG_END_SZ (Byte)(6)
#define HandCursor (Byte)(1)
extern PACKAGE Graphics::TColor ColorValues[16];
extern PACKAGE System::SmallString<7>  Colors[16];
extern PACKAGE void __fastcall CMRegister(void);

}	/* namespace Colmemo */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Colmemo;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// ColMemo
