#include <vcl\vcl.h>
#pragma hdrstop
#include <vcl\libintf.hpp>
#include <vcl\grids.hpp>

#include "codeexp_codegenp.hpp"
#include "codeexp_codegen.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------


class TCodeGenerator : public TComponent
{
public:
  __fastcall TCodeGenerator(TComponent *Owner,AnsiString ResourceName,AnsiString Title);
  __fastcall ~TCodeGenerator();
  void __fastcall Generate();
  AnsiString __fastcall GetValue(const AnsiString key,bool *found); // macro callback
  void __fastcall SetValue(AnsiString key,AnsiString val);
protected:
  // These values are constructed dynamically
  TStringList *nUserVals,*nUserKeys;     // user variables
  TStringList *nCreateCode;   // variable names for form flags given to --CreateForm
  bool xScript;               // Are we getting the overriding script?
  bool xHeader;               // (for forms) Are we generating .h or .cpp?
  bool xOption;               // (for project) are we generation option or not?
  AnsiString xExpertPath;     // directory (without trailing slash) where expert is
  AnsiString xCreatedProject; // All the xCreatedWhatever are given by the creators
  AnsiString xCreatedForm;    // so we can refer to them, even if we (perhaps) gave
  AnsiString xCreatedUnit;    // an empty string as the name
  AnsiString xCreatedAncestor;
  //
  AnsiString ResourceName; AnsiString Title;
  void __fastcall err(const AnsiString t);
  TFormDesigner* __fastcall GetFormDesigner(TIFormInterface *fi);
  TStream *MacroStream;
  AnsiString __fastcall GetModuleSource(bool h,AnsiString uid,AnsiString fid,AnsiString aid);
  AnsiString __fastcall GetProjectSource(bool opt,AnsiString pn);
  //
  void __fastcall ScriptSetProperty(TIComponentInterface *ci,TFormDesigner *Designer,AnsiString prop,AnsiString val);
  void __fastcall ScriptSetPropertyProc(TPropertyEditor *prop);
  void __fastcall ScriptSetComponent(TIComponentInterface *ci,TFormDesigner *Designer,AnsiString val);
  AnsiString ScriptSetProp; AnsiString ScriptSetVal; bool ScriptDidSet;
  AnsiString __fastcall ScriptGetProperty(TIComponentInterface *ci,TFormDesigner *Designer,AnsiString prop);
  void __fastcall ScriptGetPropertyProc(TPropertyEditor *prop);
  //
};


class TCodeGenGetValuesForm : public TForm
{
public:
  __fastcall TCodeGenGetValuesForm(TComponent* Owner);
  void __fastcall Execute(TStrings *keys,TStrings *values);
  TPanel *Panel;
  TStringGrid *StringGrid;
  TButton *btnClose;
  void __fastcall FormResize(TObject *Sender);
};


__fastcall TCodeGenGetValuesForm::TCodeGenGetValuesForm(TComponent* Owner)
    : TForm(Owner,0)
{ Position=poScreenCenter; OnResize=FormResize; Caption="Enter Values";
  Panel=new TPanel(this); Panel->Parent=this; Panel->BevelOuter=bvNone; Panel->Width=75; Panel->Align=alRight;
  btnClose=new TButton(this); btnClose->Parent=Panel; btnClose->SetBounds(7,17,62,31); btnClose->Caption="&Close"; btnClose->Default=true; btnClose->ModalResult=1;
  StringGrid=new TStringGrid(this); StringGrid->Parent=this; StringGrid->ColCount=2; StringGrid->DefaultColWidth=100; StringGrid->FixedRows=0; StringGrid->FixedCols=0; StringGrid->ScrollBars=ssVertical; StringGrid->Align=alClient;
  StringGrid->Options = StringGrid->Options << goFixedVertLine << goFixedHorzLine << goVertLine << goHorzLine << goDrawFocusSelected << goEditing << goAlwaysShowEditor;
  FormResize(this);
}
//---------------------------------------------------------------------------
void __fastcall TCodeGenGetValuesForm::FormResize(TObject *Sender)
{ int w=StringGrid->GridWidth;
  StringGrid->ColWidths[0]=100;
  int i=w-100-3*StringGrid->GridLineWidth; if (i<0) i=0;
  StringGrid->ColWidths[1]=i;
}
//---------------------------------------------------------------------------
void __fastcall TCodeGenGetValuesForm::Execute(TStrings *keys,TStrings *values)
{ int n=keys->Count;
  StringGrid->RowCount=n;
  StringGrid->Cols[0]->Assign(keys);
  StringGrid->Cols[1]->Assign(values);
  ShowModal();
  keys->Assign(StringGrid->Cols[0]);
  values->Assign(StringGrid->Cols[1]);
}



void __fastcall CodeGen(AnsiString ResourceName,AnsiString ResourceTitle,TStrings *str)
{ TCodeGenerator *cg=new TCodeGenerator(Application,ResourceName,ResourceTitle);
  if (str!=NULL)
  { for (int i=0; i<str->Count; ++i)
    { AnsiString s=str->Strings[i];
      int pos=s.Pos("=");
      if (pos!=0)
      { AnsiString key=s.SubString(1,pos-1);
        AnsiString val=s.SubString(pos+1,s.Length()-pos);
        cg->SetValue(key,val);
      }
    }
  }
  cg->Generate();
  delete cg;
}


void __fastcall CodeGenNotAutoCreate(AnsiString FormName);
void __fastcall CodeGenEnsureUniqueName(AnsiString *UnitName, AnsiString *FormName, AnsiString *Dir);
// You can pass suggested values in UnitName and FormName. If you don't want to,
// then you should ensure that you pass empties.
enum TCodeGenGetFormModuleInterfaceDisposition {gmiOpenFormIfNecessary,gmiOpenSourceIfNecessary,gmiOnlyIfAlreadyOpen};
TIModuleInterface *CodeGenGetFormModuleInterfaceEx(AnsiString form, TCodeGenGetFormModuleInterfaceDisposition disp);

AnsiString CodeGenGetFileNameFromFormName(AnsiString FormName);
AnsiString CodeGenGetFormNameFromFileName(AnsiString FileName);


AnsiString __fastcall bval(bool v) {return v?"true":"";}


typedef struct tagIf { bool ok; char marker; tagIf *next; } TIf;
typedef struct tagDefine { AnsiString key; AnsiString val; tagDefine *next; } TDefine;
enum TParseState {psStart,psData,psEnd1,psEnd2,psEnd3,psEnd4,psEnd5,psEnd6,psEnd7,psEnd8,psEnd9,psEnd10,psDone};

class TMac : public TObject
{
public:
  __fastcall TMac(TStream *in,TCodeGenGetValueFunc gv,TCodeGenErrorFunc onerr);
  __fastcall ~TMac();
  bool __fastcall GetNextLine(AnsiString *s);
protected:
  TStream *SIn;
  TCodeGenGetValueFunc GetValueFunc;
  TCodeGenErrorFunc OnErrorFunc;
  TIf *ifs;
  bool ifok;
  bool isdefining;
  AnsiString definekey;
  AnsiString definevalue;
  int donedefinelines;
  TDefine *defs;
  TStringList *SOut; AnsiString SOutLine;
protected:
  TParseState State;
  char *buf; char *cp;
  bool start; // are we at the start of a line?
  bool inp;  // are we in the middle of a percent thing?
  bool inpline; // Did this percent thing start at the beginning of the line?
  char *inpstart;  // where did the inp thing start?
  bool inreg;  // are we in regular stuff?
  char *regstart;  // where did the regular line start?
  int linenum;
protected:
  AnsiString __fastcall GetValue(AnsiString key);
  void __fastcall Define(AnsiString key,AnsiString value);
  void __fastcall op(char *c,bool endline);
  void __fastcall pp(char *c,bool startline,bool endline);
  void __fastcall bif(bool sense,char marker,char *name);
  void __fastcall bifeq(bool sense,char marker,char *key,char *val);
  void __fastcall eif(char marker);
  void __fastcall var(char *name);
};




void __fastcall NotAutoCreate(AnsiString FormName)
{ AnsiString fn=ToolServices->GetProjectName();
  TIModuleInterface *mi=ToolServices->GetModuleInterface(fn);
  if (mi==NULL) return;
  TIEditorInterface *ei=mi->GetEditorInterface();
  if (ei==NULL) {mi->Release();return;}
  TEditorStrings *es=new TEditorStrings(ei);
  AnsiString match="Application->CreateForm(__classid(T"+FormName+")";
  int found=-1;
  for (int i=0; i<es->Count && found==-1; ++i)
  { AnsiString s=es->Strings[i];
    if (s.Pos(match)!=0) found=i;
  }
  if (found!=-1)
  { es->Delete(found);
    es->SaveToEditor(ei);
  }
  delete es;
  ei->Release();
  mi->Release();
}



typedef struct tagTAPEnumModuleData {AnsiString form; AnsiString file; bool lookforfile;} TAPEnumModuleData;
bool __stdcall TAPEnumModuleProc(void*p,const AnsiString FileName,const AnsiString UnitName,const AnsiString FormName)
{ TAPEnumModuleData *data=(TAPEnumModuleData*)p;
  if (data->lookforfile)
  { if (data->form.LowerCase()==FormName.LowerCase()) data->file=FileName;
  }
  else
  { if (data->file.LowerCase()==FileName.LowerCase()) data->form=FormName;
  }
  return true;
}
AnsiString GetFileNameFromFormName(AnsiString FormName)
{ TAPEnumModuleData data; data.form=FormName; data.file=""; data.lookforfile=true;
  ToolServices->EnumProjectUnits(TAPEnumModuleProc,(void*)&data);
  return data.file;
}
AnsiString GetFormNameFromFileName(AnsiString FileName)
{ TAPEnumModuleData data; data.form=""; data.file=FileName; data.lookforfile=false;
  ToolServices->EnumProjectUnits(TAPEnumModuleProc,(void*)&data);
  return data.form;
}



TIModuleInterface *GetFormModuleInterfaceEx(AnsiString form,TCodeGenGetFormModuleInterfaceDisposition disp)
{ TIModuleInterface *mi=ToolServices->GetFormModuleInterface(form);
  if (mi!=NULL) return mi;
  if (disp==gmiOnlyIfAlreadyOpen) return NULL;
  //
  AnsiString fn=GetFileNameFromFormName(form);
  if (fn=="") return NULL;
  //
  TCreateModuleFlags cf; cf << cmExisting;
  if (disp==gmiOpenSourceIfNecessary)
  { return ToolServices->CreateModuleEx(fn,form,"","",NULL,NULL,cf);
  }
  //
  ToolServices->OpenFile(fn);
  return ToolServices->GetFormModuleInterface(form);
}



typedef struct tagEnumData
{ bool foundduplicate;
  AnsiString tryunit;
  AnsiString tryform;
} TEnumData;

bool __stdcall EnsureUniqueEnumProc(void *vd,AnsiString fn,AnsiString un,AnsiString form)
{ TEnumData *ed=(TEnumData *)vd;
  if (ed->tryunit==un) { ed->foundduplicate=true; return false; }
  if (ed->tryform==form){ed->foundduplicate=true; return false; }
  return true;
}

void __fastcall EnsureUniqueName(AnsiString *UnitName,AnsiString *FormName, AnsiString *Dir)
{ AnsiString newunitname,newfilename,newformname;
  bool res=ToolServices->GetNewModuleName(newunitname,newfilename);
  if (!res)
  { if (*UnitName=="") *UnitName="BadTools.cpp";
    if (*FormName=="") *FormName="BadToolsForm";
    *Dir="";
    return;
  }
  newunitname.LowerCase();
  char c[2]; c[0]=newunitname[1]; c[1]=0; strupr(c); newunitname[1]=c[0];
  newformname="Form"+newunitname.SubString(5,245);
  if (*UnitName!="") newunitname=*UnitName;
  if (*FormName!="") newformname=*FormName;
  // So, that will have put in as our starting point the place where we want to go.
  //
  // Maybe (especially if the thing was left blank) that will end in a number.
  // It would be nice to generate a sequence of numbers.
  AnsiString num=newformname.SubString(5,245); // hopefully a number
  int number;
  int ires=0;
  try {number=num.ToInt(); ires=1;} catch (EConvertError &err) {}
  bool isnumber=false;
  if (ires==1) isnumber=true; else number=0;
  // if isnumber, then we can increment it for later ones. If not a number,
  // then we will stick numbers to the end.
  TEnumData ed; ed.tryunit=newunitname; ed.tryform=newformname;
  do
  { ed.foundduplicate=false;
    ToolServices->EnumProjectUnits(EnsureUniqueEnumProc,&ed);
    if (ed.foundduplicate)
    { ++number;
      if (isnumber)
      { ed.tryunit=newunitname.SubString(1,4)+number;
        ed.tryform=newformname.SubString(1,4)+number;
      }
      else
      { ed.tryunit=newunitname+number;
        ed.tryform=newformname+number;
      }
      // the first version will add number strings on in place of the initial number
      // (ie. Form1, Form2, Form3, ...);
      // the second will add then after
      // (ie. Gobbledegook,Gobbledegook1,Gobbledegook2 ...)
    }
  } while (ed.foundduplicate);
  //
  *UnitName=ed.tryunit; *FormName=ed.tryform;
  if (*Dir=="") *Dir=ExtractFilePath(newfilename);
}




AnsiString __fastcall CodeGenParse(TStream *in,TCodeGenGetValueFunc gv,TCodeGenErrorFunc onerr)
{ TMac *p=new TMac(in,gv,onerr);
  TStringList *sl=new TStringList(); AnsiString t="";
  sl->BeginUpdate();
  bool more=true;
  while (more)
  { more=p->GetNextLine(&t);
    if (more)
    { sl->Add(t);
    }
  }
  sl->EndUpdate();
  delete p;
  t=sl->Text;
  delete sl;
  return t;
}








__fastcall TMac::TMac(TStream *in,TCodeGenGetValueFunc gv,TCodeGenErrorFunc onerr) : TObject()
{ SIn=in; GetValueFunc=gv; isdefining=false; donedefinelines=0; defs=NULL;
  SOut=new TStringList(); SOutLine=""; ifs=NULL; ifok=true; State=psStart;
  OnErrorFunc=onerr;
}

__fastcall TMac::~TMac()
{ while (ifs!=NULL)
  { TIf *i=ifs;
    ifs=ifs->next;
    delete i;
  }
  while (defs!=NULL)
  { TDefine *d=defs;
    defs=defs->next;
    delete d;
  }
  if (SOut!=NULL) delete SOut; SOut=NULL;
}

void __fastcall TMac::bif(bool sense,char marker,char *name)
{ AnsiString res;
  if (ifok)
  { res=GetValue(name);
    if (res.SubString(1,12)=="***undefined")
    { op("<-UNKNOWN COND ",false);
      op(name,false);
      op("->",false);
      res="";
      // but still do the if
    }
  }
  else
  { res="dont-care";
  }
  bool def;
  if (res=="") def=false; else def=true;
  bool ok;
  if (sense) ok=def; else ok=!def;
  if (ifs==NULL) ifok=ok; else ifok=ok && ifs->ok;
  TIf *oldifs=ifs;
  ifs=new TIf;
  ifs->ok=ifok; ifs->marker=marker; ifs->next=oldifs;
}

void __fastcall TMac::bifeq(bool sense,char marker,char *key,char *val)
{ AnsiString res;
  if (ifok)
  { res=GetValue(key);
    if (res.SubString(1,12)=="***undefined")
    { op("<-UNKNOWN COND ",false);
      op(key,false);
      op("->",false);
      res="";
      // but still do the if
    }
  }
  else
  { res="dont-care";
  }
  bool eq; if (res==AnsiString(val)) eq=true; else eq=false;
  bool ok; if (sense) ok=eq; else ok=!eq;
  if (ifs==NULL) ifok=ok; else ifok=ok && ifs->ok;
  TIf *oldifs=ifs;
  ifs=new TIf;
  ifs->ok=ifok; ifs->marker=marker; ifs->next=oldifs;
}


void __fastcall TMac::eif(char marker)
{ if (ifs==NULL)
  { ifok=true;
    op("<-EXTRA END ",false);
    char c[2]; c[0]=marker; c[1]=0;
    op(c,false);
    op(" NO IFS->",false);
    ifok=false;
    return;
  }
  if (ifs->marker!=marker)
  { ifok=true;
    op("<-ENDIF ",false);
    char c[2]; c[0]=marker; c[1]=0;
    op(c,false);
    op(", WANTED ",false);
    c[0]=ifs->marker; c[1]=0;
    op(c,false);
    op("->",false);
    ifok=false;
    return;
  }
  TIf *oldif=ifs;
  ifs=ifs->next;
  if (ifs==NULL) ifok=true; else ifok=ifs->ok;
  delete oldif;
}

void __fastcall TMac::var(char *name)
{ if (ifok) op(GetValue(name).c_str(),false);
  else op("dont-care",false);
}


AnsiString __fastcall TMac::GetValue(AnsiString key)
{ bool b=false; AnsiString res="";
  if (GetValueFunc!=NULL) res=GetValueFunc(key,&b);
  if (b) return res;
  TDefine *d=defs;
  while (d!=NULL)
  { if (key==d->key) return d->val;
    d=d->next;
  }
  res="***undefined-"+key+"***";
  if (OnErrorFunc!=NULL) OnErrorFunc(res);
  return res;
}

void __fastcall TMac::Define(AnsiString key,AnsiString value)
{ TDefine *def=new TDefine;
  def->key=key;
  def->val=value;
  def->next=defs;
  defs=def;
}



void __fastcall TMac::op(char *c,bool endline)
{ if (isdefining && endline)
  { ++donedefinelines;
  }
  if (isdefining && donedefinelines<=3)
  { AnsiString ex=AnsiString(c);
    if (!ex.IsEmpty())
    { if (ex[ex.Length()]=='\r') ex=ex.SubString(1,ex.Length()-1);
    }
    definevalue=definevalue+ex;
    return;
  }
  if (!ifok) return;
  SOutLine=SOutLine+AnsiString(c);
  if (!endline) return;
  if (SOutLine.Length()>=1 && (SOutLine[SOutLine.Length()]=='\r' || SOutLine[SOutLine.Length()]=='\n')) SOutLine=SOutLine.SubString(1,SOutLine.Length()-1);
  if (SOutLine.Length()>=1 && (SOutLine[SOutLine.Length()]=='\r' || SOutLine[SOutLine.Length()]=='\n')) SOutLine=SOutLine.SubString(1,SOutLine.Length()-1);
  SOut->Add(SOutLine); SOutLine="";
}
void __fastcall TMac::pp(char *c,bool startline,bool endline)
{ if (endline && !startline) {op("<-UNFINISHED LINE->\r",true); return;}
  if (*c=='\r' && endline) return; // % on its own for padding
  if (*c==0 && endline) return; // ditto
  if (*c==0 && !endline) {op("%",false); return;}  // %% -> %
  if (*c=='c') return; // %c -> comment
  if (*c==' ') return;

  // ENDLDEF
  if (c[0]=='e' && c[1]=='n' && c[2]=='d' && c[3]=='l' && c[4]=='d' && c[5]=='e' && c[6]=='f')
  { bool wasdefining=isdefining;
    isdefining=false;
    char *d=c+7;
    if (*d!=' ')
    { op("<-BAD ENDKEY ",false); op(d,endline); return; }
    while (*d==' ') ++d;
    if (*d==0 || *d=='\r')
    { op("<-BAD ENDKEY ",false); op(d,endline); return; }
    char *e=d; while (*e!=' ' && *e!=0 && *e!='\r') ++e;
    *e=0; ++e;AnsiString key=AnsiString(d);
    if (!wasdefining)
    { op("<-ENDDEF BUT NOT DEFINING->",false); op(e,endline); return; }
    if (key!=definekey)
    { op("<-ENDDEF ",false);
      op(key.c_str(),false);
      op(" BUT WANTED ",false);
      op(definekey.c_str(),false);
      op("->",false);
      op(e,endline);
      return;
    }
    if (donedefinelines==0)
    { op("<-ENDDEF ",false);
      op(key.c_str(),false);
      op(" PREMATURE->",false);
      op(e,endline);
      return;
    }
    if (donedefinelines>1)
    { AnsiString err="<-ENDDEF "+key+" TOO MANY LINES :"+definevalue+": lines="+AnsiString(donedefinelines)+"->";
      op(err.c_str(),false);
      op(e,endline);
    }
    // Otherwise we're here, having met the correct %enddef, with the right number of lines
    if (ifok) Define(definekey,definevalue);
    return;
  }

  // DEFINE
  if (c[0]=='d' && c[1]=='e' && c[2]=='f' && c[3]=='i' && c[4]=='n' && c[5]=='e')
  { if (isdefining)
    { op("<-DEFINE, BUT PREVIOUS DEFINE ",false);
      op(definekey.c_str(),false);
      op(" WAS NOT ENDDEF'D->",false);
      isdefining=false; // just to finish the previous define. And start with the new.
    }
    char *d=c+6;
    if (*d!=' ')
    { op("<-BAD KEY ",false); op(d,endline); return; }
    while (*d==' ') ++d;
    if (*d==0 || *d=='\r')
    { op("<-BAD KEY ",false); op(d,endline); return; }
    char *e=d;
    while (*e!=' ' && *e!=0 && *e!='\r') ++e;
    *e=0; definekey=AnsiString(d);
    // Hmmm... maybe they had %define name val on a single line or something?
    ++e; while (*e==' ') ++e;
    if (ifok)
    { if (strlen(e)>0)
      { if (e[strlen(e)-1]=='\r') e[strlen(e)-1]=0;
      }
      Define(definekey,AnsiString(e));
    }
    return;
  }

  //
  // LDEF
  if (c[0]=='l' && c[1]=='d' && c[2]=='e' && c[3]=='f')
  { if (isdefining)
    { op("<-LDEFINE, BUT PREVIOUS DEFINE ",false);
      op(definekey.c_str(),false);
      op(" WAS NOT ENDDEF'D->",false);
      isdefining=false; // just to finish the previous define. And start with the new.
    }
    char *d=c+4;
    if (*d!=' ')
    { op("<-BAD LKEY ",false); op(d,endline); return; }
    while (*d==' ') ++d;
    if (*d==0 || *d=='\r')
    { op("<-BAD LKEY ",false); op(d,endline); return; }
    char *e=d;
    while (*e!=' ' && *e!=0 && *e!='\r') ++e;
    *e=0; definekey=AnsiString(d);
    // Hmmm... maybe they had %define name val on a single line or something?
    ++e; while (*e==' ') ++e;
    if (*e==0 || *e=='\r') // if so, they must have had no value for the define.
    { if (!startline) // if not startline, then an error: eg. %define key % (nothing)
      { op("<-BAD LDEF ",false);
        op(definekey.c_str(),false);
        op(" NOT ON OWN LINE",false);
        op(e,endline);
        return;
      }
      // otherwise it was startline, and we're about to start a multi-line definition
      isdefining=true; // the actual define will happen at the end of the line.
      donedefinelines=0;
      definevalue="";
      return;
    }
    // Otherwise, they did have a value for the define on the single line. Bad!
    op("<-BAD LDEF ",false); op(definekey.c_str(),false);
    op(" HAD VALUE ",false); op(e,endline);
    return;
  }

  // IFEQ
  if (c[0]=='i' && c[1]=='f' && c[2]=='e' && c[3]=='q')
  { char *d=c+4;
    char marker;
    if (*d==' ' || *d==0 || *d=='\r') marker='_'; else marker=*d;
    ++d;
    while (*d==' ') ++d;
    char key[MAX_PATH]; int i=0;
    while (*d!=' ' && *d!=0 && *d!='\r') {key[i]=*d; ++i; ++d;} key[i]=0;
    while (*d==' ') ++d;
    if (d[strlen(d)-1]=='\r') d[strlen(d)-1]=0;
    bifeq(true,marker,key,d);
    return;
  }

  // IFNEQ
  if (c[0]=='i' && c[1]=='f' && c[2]=='n' && c[3]=='e' && c[4]=='q')
  { char *d=c+5;
    char marker;
    if (*d==' ' || *d==0 || *d=='\r') marker='_'; else marker=*d;
    ++d;
    while (*d==' ') ++d;
    char key[MAX_PATH]; int i=0;
    while (*d!=' ' && *d!=0 && *d!='\r') {key[i]=*d; ++i; ++d;} key[i]=0;
    while (*d==' ') ++d;
    if (d[strlen(d)-1]=='\r') d[strlen(d)-1]=0;
    bifeq(false,marker,key,d);
    return;
  }

  // IFDEF
  if (c[0]=='i' && c[1]=='f' && c[2]=='d' && c[3]=='e' && c[4]=='f')
  { char *d=c+5;
    char marker;
    if (*d==' ' || *d==0 || *d=='\r') marker='_'; else marker=*d;
    ++d;
    while (*d==' ') ++d;
    if (d[strlen(d)-1]=='\r') d[strlen(d)-1]=0;
    bif(true,marker,d);
    return;
  }
  if (c[0]=='i' && c[1]=='f' && c[2]=='n' && c[3]=='d' && c[4]=='e' && c[5]=='f')
  { char *d=c+6;
    char marker;
    if (*d==' ' || *d==0 || *d=='\r') marker='_'; else marker=*d;
    ++d;
    while (*d==' ') ++d;
    if (d[strlen(d)-1]=='\r') d[strlen(d)-1]=0;
    bif(false,marker,d);
    return;
  }
  if (c[0]=='e' && c[1]=='n' && c[2]=='d' && c[3]=='i' && c[4]=='f')
  { char marker;
    if (c[5]==' ' || c[5]==0 || c[5]=='\r') marker='_'; else marker=c[5];
    eif(marker);
    return;
  }
  //if (startline && endline) return; // full-line comments if they start and are open
  // otherwise we get here, and we have a name
  if (endline)
  { int len=strlen(c);
    if (len==0) return;
    char *d=new char[len+10];
    strcpy(d,c);
    if (len>=2)
    { if (d[len-1]=='\r') d[len-1]=0;
    }
    op("<-UNRECOGNIZED COMMAND ON SINGLE-LINE ",false);
    op(d,false);
    op("->",endline);
    return;
  }
  //
  var(c);
  return;
}
// Any % can go at the start of a line at not require a closing %
// But we can also have %kkhk% dfahf at the start of a line
// The commands available are
// %% stands for a single %
// %c comment%
// %ifdefX var%  where X is an optional marker to help you match them up
// %ifndefX var%
// %endifX%
// %name%
// %define key val
// %ldef key \n one line only \n %endldef

bool __fastcall TMac::GetNextLine(AnsiString *retline)
{ if (State==psStart)
  { SIn->Position=0;
    buf=new char[SIn->Size+20];
    SIn->ReadBuffer(buf,SIn->Size);
    buf[SIn->Size]=0;
    cp=buf;
    start=true; // are we at the start of a line?
    inp=false;  // are we in the middle of a percent thing?
    inpline=false; // Did this percent thing start at the beginning of the line?
    inpstart=NULL;  // where did the inp thing start?
    inreg=false;  // are we in regular stuff?
    regstart=NULL;  // where did the regular line start?
    linenum=0;
    State=psData;
  }
  //
  if (State==psData)
  { while (*cp!=0 && SOut->Count==0)
    { if (inp)
      { // Here we are inside a percent thing
        if (*cp=='%')
        { // we're about to close the percent thing
          *cp=0;
          pp(inpstart,inpline,false);
          inp=false;
          start=false;
        }
        else
        { // we're doing normal stuff inside the percent thing
          if (*cp=='\n')
          { *cp=0; pp(inpstart,inpline,true); inp=false; start=true;
          }
          else start=false;
        }
      }
      else
      { // Here we are not inside a percent thing
        if (*cp=='%')
        { if (inreg)
          { // if we were about to start a percent thing, then we should copy the reg stuff before it
            *cp=0;
            op(regstart,false);
            inreg=false;
          }
          inpstart=cp+1;
          if (*inpstart=='%') {++inpstart;++cp;} // to skip over double%%
          inpline=start;
          inp=true;
          start=false;
        }
        else
        { // Here we were not inside a percent thing, and we're not going to start
          if (!inreg) {regstart=cp;inreg=true;}
          if (*cp=='\n')
          { *cp=0; op(regstart,true); start=true; inreg=false;
          }
          else start=false;
        }
      }
      ++cp;
    }
    if (SOut->Count>0) {++linenum; AnsiString s=SOut->Strings[0]; SOut->Delete(0); *retline=s; return true;}
    if (*cp==0) State=psEnd1;
  }
  // These two are in case the user didn't trail a LF/CR at the end
  if (State==psEnd1)
  { if (inp)
    { int len=strlen(inpstart)+5;
      char *c=new char[len];
      strcpy(c,inpstart); strcat(c,"\r");
      pp(c,inpline,true);
      delete[] c;
      inp=false;
    }
    State=psEnd2;
  }

  if (State==psEnd2)
  { if (SOut->Count>0) {++linenum; AnsiString s=SOut->Strings[0]; SOut->Delete(0); *retline=s; return true;}
    State=psEnd3;
  }

  if (State==psEnd3)
  { if (inreg)
    { int len=strlen(regstart)+5;
      char *c=new char[len];
      strcpy(c,regstart); strcat(c,"\r");
      op(c,true);
      delete[] c;
      inreg=false;
    }
    State=psEnd4;
  }

  if (State==psEnd4)
  { if (SOut->Count>0) {++linenum; AnsiString s=SOut->Strings[0]; SOut->Delete(0); *retline=s; return true;}
    State=psEnd5;
  }

  if (State==psEnd5)
  { bool wasdefining=isdefining;
    ifok=true; isdefining=false;
    if (wasdefining)
    { op("<-DEFINE ",false);
      op(definekey.c_str(),false);
      op(" WAS NOT ENDDEF'D->\r",true);
    }
    State=psEnd6;
  }

  if (State==psEnd6)
  { if (SOut->Count>0) {++linenum; AnsiString s=SOut->Strings[0]; SOut->Delete(0); *retline=s; return true;}
    State=psEnd7;
  }

  if (State==psEnd7)
  { if (ifs!=NULL)
    { op("<-IFS OUTSTANDING: ",false);
      while (ifs!=NULL)
      { TIf *i=ifs;
        ifs=ifs->next;
        char c[3]; c[0]=i->marker; c[1]=' '; c[2]=0;
        op(c,false);
        delete i;
      }
      op("->\r",true);
    }
    op("\r",true);
    State=psEnd8;
  }

  if (State==psEnd8)
  { if (SOut->Count>0) {++linenum;AnsiString s=SOut->Strings[0]; SOut->Delete(0); *retline=s; return true;}
    State=psEnd9;
  }
  //
  if (State==psEnd9)
  { if (SOutLine!="") {*retline=SOutLine; SOutLine=""; return true;}
    State=psEnd10;
  }

  if (State==psEnd10)
  { delete[] buf; State=psDone;
  }

  return false;
}






typedef AnsiString __fastcall (__closure *TCodeGenGetSourceEvent)(bool h,AnsiString uid,AnsiString fid,AnsiString aid);
class TAutoModuleCreator : public TIModuleCreatorEx
{
public:
  __fastcall TAutoModuleCreator(TCodeGenGetSourceEvent ags,TCodeGenErrorFunc onerr) : TIModuleCreatorEx() {GetSource=ags; OnError=onerr;bExisting=false;}
  TCodeGenGetSourceEvent GetSource; TCodeGenErrorFunc OnError;
  AnsiString nFormAncestor;
  AnsiString nForm;
  AnsiString nUnit;
  AnsiString nDir;
  TCreateModuleFlags cmFlags;
  bool bExisting;
  //
  bool __stdcall Existing() {return bExisting;}
  AnsiString __stdcall GetAncestorName() {return nFormAncestor;}
  AnsiString __stdcall GetFileName() {return nDir+nUnit+".cpp";}
  AnsiString __stdcall GetIntfName() {return nDir+nUnit+".h";}
  AnsiString __stdcall GetFileSystem() {return "";}
  AnsiString __stdcall GetFormName() {return nForm;}
  void __stdcall FormCreated(TIFormInterface *newfi)
  { Application->MessageBox("Checked my form interface","Title",MB_OK);
  }
  AnsiString __stdcall NewModuleSource(const AnsiString uid,const AnsiString fid,const AnsiString aid) {return GetSource(false,uid,fid,aid);}
  AnsiString __stdcall NewIntfSource(const AnsiString uid,const AnsiString fid,const AnsiString aid)   {return GetSource(true,uid,fid,aid);}
  bool __fastcall Execute(TIFormInterface **pfi)
  { TIModuleInterface *mi=NULL; bool okay=true;
    try {mi=ToolServices->ModuleCreateEx(this,cmFlags);}
    catch (Exception &e)
    { if (OnError!=NULL) OnError(AnsiString(e.ClassName())+": "+e.Message); okay=false;
    }
    if (mi!=NULL)
    { if (pfi!=NULL) *pfi=mi->GetFormInterface();
      mi->Release();
    }
    return okay;
  }
};




class TAutoFileCreator : public TIModuleCreator
{
public:
  __fastcall TAutoFileCreator(TCodeGenGetSourceEvent ags,TCodeGenErrorFunc onerr) : TIModuleCreator() {GetSource=ags; OnError=onerr;bExisting=false;}
  TCodeGenGetSourceEvent GetSource; TCodeGenErrorFunc OnError;
  TCreateModuleFlags cmFlags;
  AnsiString nUnit;
  AnsiString nSuffix;
  AnsiString nDir;
  bool bExisting;
  //
  bool __stdcall Existing() {return bExisting;}
  AnsiString __stdcall GetAncestorName() {return "";}
  AnsiString __stdcall GetFileName() {return nDir+nUnit+nSuffix;}
  AnsiString __stdcall GetFileSystem() {return "";}
  AnsiString __stdcall GetFormName() {return "";}
  void __stdcall FormCreated(TIFormInterface *newfi) {}
  AnsiString __stdcall NewModuleSource(const AnsiString uid,const AnsiString fid,const AnsiString aid) {return GetSource(false,uid,fid,aid);}
  bool __fastcall Execute(TIFormInterface **pfi)
  { TIModuleInterface *mi=NULL; bool okay=true;
    try {mi=ToolServices->ModuleCreate(this,cmFlags);}
    catch (Exception &e)
    { if (OnError!=NULL) OnError(AnsiString(e.ClassName())+": "+e.Message); okay=false;
    }
    if (mi!=NULL)
    { if (pfi!=NULL) *pfi=mi->GetFormInterface();
      mi->Release();
    }
    return okay;
  }
};



typedef AnsiString __fastcall (__closure *TCodeGenGetProjectEvent)(bool opt, AnsiString proj);
class TAutoProjectCreator : public TIProjectCreatorEx
{
public:
  __fastcall TAutoProjectCreator(TCodeGenGetProjectEvent ags,TCodeGenErrorFunc onerr) : TIProjectCreatorEx() {GetSource=ags; OnError=onerr;bExisting=false;}
  TCodeGenGetProjectEvent GetSource; TCodeGenErrorFunc OnError;
  AnsiString nFileName;
  AnsiString nOptionName;
  TCreateProjectFlags cpFlags;
  bool bExisting;
  //
  bool __stdcall Existing() {return bExisting;}
  AnsiString __stdcall GetFileName() {return nFileName;}
  AnsiString __stdcall GetFileSystem() {return "";}
  AnsiString __stdcall NewProjectSource(AnsiString ProjectName) {return GetSource(false,ProjectName);}
  AnsiString __stdcall GetOptionName() {return nOptionName;}
  AnsiString __stdcall NewOptionSource(AnsiString ProjectName) {return GetSource(true,ProjectName);}
  void __stdcall NewProjectResource(TIModuleInterface *mi)
  { Application->MessageBox("Checked my module interface","Title",MB_OK);
  }
  void __stdcall NewDefaultModule() {}
  bool __fastcall Execute()
  { TIModuleInterface *mi=NULL; bool okay=true;
    try {ToolServices->ProjectCreateEx(this,cpFlags);}
    catch (EAbort &e) {okay=false;}
    catch (Exception &e) {if (OnError!=NULL) OnError(AnsiString(e.ClassName())+": "+e.Message); okay=false;}
    if (mi!=NULL) mi->Release();
    return okay;
  }
};




void __fastcall FromCommaText(TStringList *sl,AnsiString src)
{ sl->Clear();
  // The comma text will be in the form
  // item, maybe an item with spaces, "maybe with quotes", "comma, in quotes"
  // spaces: the numer of spaces so far that we haven't yet committed
  // inquotes: are we in quotes or not?
  // s: the current item being processed
  char *c=src.c_str(); AnsiString spaces=""; bool inquotes=false;
  while (*c!=0)
  { AnsiString s="";
    while (*c==' ') ++c;  // spaces at beginning of item
    bool endofitem=false;
    while (!endofitem)
    { char a=*c; ++c;
      if (a==' ') spaces=spaces+" ";
      else if (a=='"')
      { if (inquotes) {s=s+spaces;spaces="";inquotes=false;}
        else {spaces="";inquotes=true;}
      }
      else if (a==',')
      { if (inquotes) {s=s+spaces+",";spaces="";}
        else {endofitem=true;spaces="";}
      }
      else if (a==0) {endofitem=true;c--;}
      else if (a=='\\' && *c=='\\') {s=s+spaces+'\\';spaces="";++c;}
      else if (a=='\\' && *c=='"') {s=s+spaces+'"';++c;}
      else {s=s+spaces+a;spaces="";}
    }
    sl->Add(s);
  }
}


__fastcall TCodeGenerator::TCodeGenerator(TComponent *Owner,AnsiString ares,AnsiString tit) : TComponent(Owner)
{ nCreateCode=new TStringList(); nUserVals=new TStringList(); nUserKeys=new TStringList();
  char c[MAX_PATH]; GetModuleFileName(HInstance,c,MAX_PATH); AnsiString mod=AnsiString(c);
  AnsiString dir=ExtractFilePath(mod);
  if (dir[dir.Length()]=='\\') dir=dir.SubString(1,dir.Length()-1);
  xExpertPath=dir;
  ResourceName=ares; Title=tit;
  xCreatedProject=""; xCreatedForm=""; xCreatedUnit=""; xCreatedAncestor="";
}
__fastcall TCodeGenerator::~TCodeGenerator()
{ if (nCreateCode!=NULL) delete nCreateCode; nCreateCode=NULL;
  if (nUserVals!=NULL) delete nUserVals; nUserVals=NULL;
  if (nUserKeys!=NULL) delete nUserKeys; nUserKeys=NULL;
}

void __fastcall TCodeGenerator::err(const AnsiString as)
{ if (GetAsyncKeyState(VK_SHIFT)>=0) Application->MessageBox(as.c_str(),("Error in "+Title).c_str(),MB_OK);
}







void __fastcall TCodeGenerator::SetValue(AnsiString key,AnsiString val)
{ int pu=nUserKeys->IndexOf(key);
  if (pu==-1) {nUserKeys->Add(key); nUserVals->Add(val);}
  else nUserVals->Strings[pu]=val;
}


AnsiString __fastcall TCodeGenerator::GetValue(const AnsiString key,bool *found)
{ if (found!=NULL) *found=true;
  // dynamically generated by user
  int pu=nUserKeys->IndexOf(key); if (pu!=-1) return nUserVals->Strings[pu];
  //
  // dynamically generated by --CreateCode
  int pp=nCreateCode->IndexOf(key+"+"), pm=nCreateCode->IndexOf(key+"-");
  if (pp!=-1) return bval(true); else if (pm!=-1) return bval(false);
  //
  // dynamically according to what we're doing
  if (key=="xScript") return bval(xScript);
  if (key=="xHeader") return bval(xHeader);
  if (key=="xOption") return bval(xOption);
  if (key=="xExpertPath") return xExpertPath;
  if (key=="xCreatedProject") return xCreatedProject;
  if (key=="xCreatedForm") return xCreatedForm;
  if (key=="xCreatedUnit") return xCreatedUnit;
  if (key=="xCreatedAncestor") return xCreatedAncestor;
  //
  // otherwise we couldn't find it!
  if (found!=NULL) *found=false; return "";
}


AnsiString __fastcall TCodeGenerator::GetModuleSource(bool h,AnsiString uid,AnsiString fid,AnsiString aid)
{ xCreatedUnit=uid; xCreatedForm=fid; xCreatedAncestor=aid;
  bool os=xScript, oh=xHeader; xScript=false; xHeader=h;
  AnsiString s=CodeGenParse(MacroStream,GetValue,err);
  xScript=os; xHeader=oh; return s;
}
AnsiString __fastcall TCodeGenerator::GetProjectSource(bool opt,AnsiString proj)
{ xCreatedProject=proj;
  bool os=xScript, oo=xOption; xScript=false; xOption=opt;
  AnsiString s=CodeGenParse(MacroStream,GetValue,err);
  xScript=os; xOption=oo; return s;
}

void __fastcall TCodeGenerator::ScriptSetPropertyProc(TPropertyEditor *prop)
{ AnsiString sp, rp;
  int pos=ScriptSetProp.Pos(".");
  if (pos==0) {sp=ScriptSetProp; rp="";}
  else {sp=ScriptSetProp.SubString(1,pos-1); rp=ScriptSetProp.SubString(pos+1,ScriptSetProp.Length()-pos);}
  AnsiString pn=prop->GetName();
  if (pn!=sp) return;
  if (pos==0) {prop->SetValue(ScriptSetVal); ScriptDidSet=true; return;}
  ScriptSetProp=rp; prop->GetProperties(ScriptSetPropertyProc);
}
void __fastcall TCodeGenerator::ScriptSetProperty(TIComponentInterface *ci,TFormDesigner *Designer,AnsiString prop,AnsiString val)
{ TComponent *c=(TComponent*)ci->GetComponentHandle(); if (c==NULL) return;
  TComponentList *list=new TComponentList(); list->Add(c);
  TTypeKinds kinds; kinds << tkUnknown << tkInteger << tkChar << tkEnumeration << tkFloat
    << tkString << tkSet << tkClass << tkMethod << tkWChar << tkLString << tkWString
    << tkVariant << tkArray << tkRecord << tkInterface;
  ScriptSetProp=prop; ScriptSetVal=val;
  ScriptDidSet=false;
  GetComponentProperties(list,kinds,Designer,ScriptSetPropertyProc);
  delete list;
  if (!ScriptDidSet) err("Could not find property "+prop);
}

void __fastcall TCodeGenerator::ScriptGetPropertyProc(TPropertyEditor *prop)
{ AnsiString sp, rp;
  int pos=ScriptSetProp.Pos(".");
  if (pos==0) {sp=ScriptSetProp; rp="";}
  else {sp=ScriptSetProp.SubString(1,pos-1); rp=ScriptSetProp.SubString(pos+1,ScriptSetProp.Length()-pos);}
  AnsiString pn=prop->GetName();
  if (pn!=sp) return;
  if (pos==0) {ScriptSetVal=prop->GetValue(); ScriptDidSet=true; return;}
  ScriptSetProp=rp; prop->GetProperties(ScriptGetPropertyProc);
}
AnsiString __fastcall TCodeGenerator::ScriptGetProperty(TIComponentInterface *ci,TFormDesigner *Designer,AnsiString prop)
{ TComponent *c=(TComponent*)ci->GetComponentHandle(); if (c==NULL) return "";
  TComponentList *list=new TComponentList(); list->Add(c);
  TTypeKinds kinds; kinds << tkUnknown << tkInteger << tkChar << tkEnumeration << tkFloat
    << tkString << tkSet << tkClass << tkMethod << tkWChar << tkLString << tkWString
    << tkVariant << tkArray << tkRecord << tkInterface;
  ScriptSetProp=prop; ScriptSetVal=""; ScriptDidSet=false;
  GetComponentProperties(list,kinds,Designer,ScriptGetPropertyProc);
  delete list;
  if (!ScriptDidSet) err("Could not find property "+prop);
  return ScriptSetVal;
}

void __fastcall TCodeGenerator::ScriptSetComponent(TIComponentInterface *ci,TFormDesigner *Designer,AnsiString op)
{ TComponent *c=(TComponent*)ci->GetComponentHandle(); if (c==NULL) return;
  TComponentEditor *com=GetComponentEditor(c,Designer);
  if (com==NULL) {err("Could not find component editor");return;}
  AnsiString ops="";
  int count=com->GetVerbCount();
  bool found=false;
  for (int i=0; i<count; ++i)
  { AnsiString s=com->GetVerb(i);
    if (op==s) {com->ExecuteVerb(i);found=true;}
    ops=ops+s+", ";
  }
  delete com;
  if (!found) err("Could not find component-editor method "+op+" out of "+ops);
}

void __fastcall TCodeGenerator::Generate()
{ if (ResourceName.Length()==0) {err("Macro "+ResourceName+" not found");return;}
  MacroStream=new TMemoryStream();
  if (ResourceName[1]=='*')
  { TResourceStream *temps=new TResourceStream((int)HInstance,ResourceName.SubString(2,ResourceName.Length()-1),RT_RCDATA);
    temps->SaveToStream(MacroStream);
    delete temps;
  }
  else
  { TFileStream *temps=new TFileStream(ResourceName,fmOpenRead|fmShareDenyWrite);
    MacroStream->CopyFrom(temps,temps->Size);
    delete temps;
  }
  MacroStream->Position=0;

  // This is the format of the script file that we understand:
  // It has a notion of 'current form' and 'current component'. When you
  // CreateForm sets current-form and current-component to the newly created
  // CreateComponent creates it in the current-form and sets current-component to newly created
  // FindComponent also sets current-component
  // OpenForm sets current-form and current-component to the newly opened
  // GetVals is only to interrogate the user for setting variables
  // --GetVals=nThis,nThat
  // --SetVal=Key,Val
  // --Call=xresource
  // --MessageBox=body,title,MB_OK|MB_OKCANCEL|MB_YESNO,key
  // --CreateForm=nAncestor,nForm,nUnit,nDir,bConfigCode,cmAddToProject|cmMarkModified|cmShowForm|cmShowSource|cmUnNamed
  // --NotAutoCreate=nForm
  // --CreateFile=nUnit,nSuffix,nDir,bConfigCode,cmFlags
  // --SaveFile=nDir,nUnit,nSuffix,bCode
  // --CreateProject=nFileName,nOptionName,cbConfigCode,pCustom|cpApplication|cpLibrary|cpCanShowSource
  // --CloseProject=result
  // --OpenProject=name
  // --EnsureUniqueName=nForm,nUnit,xDir
  // --CreateComponent=TButton,Container,50,50,100,100
  // --OpenForm=nForm
  // --FindComponent=nComponent
  // --FindFormComponent
  // --GetSubComponent=int
  // --AddIntRange(caption,min,def,max). AddIndexRange. AddFloatRange.
  // --IsFormValid=key. --IsComponentValid=key.  --IsProjectValid=key.
  // --GetProp=Prop,key
  // --Icon=*SCRPLUS|*BCB|*SETUP|*SCRICON1|*SCRICON2|*SCRICON3 or filename for TImage components
  // --Bitmap=*SCRPLUS|*SCRCORNERS|*SCRMONITOR or filename for TImage components
  // --IsComponentInstalled=name,key
  // Property=Value uses the property editor to set the value of the current-component
  // :Verb invokes a verb from the component editor

  MacroStream->Position=0; xScript=true;
  TMac *mac=new TMac(MacroStream,&GetValue,&err);

  // Now follow the script!
  TIFormInterface *fi=NULL;       // CreateComponents will go here. Set by CreateForm,GetFormComponent,OpenForm
  TIComponentInterface *ci=NULL;  // Properties will be assigned here. Set by GetFormComponent,FindComponent
  TFormDesigner *Designer;        // The designer for the current form
  bool ProjectValid=(ToolServices->GetProjectName()!="");
  AnsiString CurrentLine=""; bool gotmore=mac->GetNextLine(&CurrentLine);
  while (gotmore)
  { AnsiString src=CurrentLine; AnsiString arg,cmd; char op=0;
    int eqpos=src.Pos("=");
    int bkpos=src.Pos("(");
    int copos=src.Pos(":");
    int min=0;
    if (eqpos!=0) min=eqpos; if (bkpos!=0) min=bkpos; if (copos!=0) min=copos;
    if (eqpos!=0 && eqpos<=min) {min=eqpos;op='=';}
    if (bkpos!=0 && bkpos<=min) {min=bkpos;op='(';}
    if (copos!=0 && copos<=min) {min=copos;op=':';}
    if (min==0) {cmd=src; arg="";op=0;}
    else
    { cmd=src.SubString(1,min-1).Trim();
      int max=src.Length()-min; if (op=='(') max=max-1;
      arg=src.SubString(min+1,max).Trim();
    }


    if (cmd.SubString(1,6)=="--Call")
    { TCodeGenerator *gen=new TCodeGenerator(this,arg,Title+"->"+arg);
      for (int i=0; i<nUserKeys->Count; ++i)
      { AnsiString key=nUserKeys->Strings[i]; AnsiString val=nUserVals->Strings[i];
        gen->SetValue(key,val);
      }
      gen->Generate();
      delete gen;
    }


    else if (cmd.SubString(1,22)=="--IsComponentInstalled")
    { TStringList *parms=new TStringList(); FromCommaText(parms,arg);
      if (parms->Count!=2) err("IsComponentInstalled: expecting TComponent,key but got "+arg);
      else
      { AnsiString search=parms->Strings[0];
        bool found=false; AnsiString founds="";
        int mc=ToolServices->GetModuleCount();
        for (int mod=0; mod<mc && !found; ++mod)
        { AnsiString smod=ToolServices->GetModuleName(mod);
          int cc=ToolServices->GetComponentCount(mod);
          for (int com=0; com<cc && !found; ++com)
          { AnsiString sc=ToolServices->GetComponentName(mod,com);
            if (sc==search) {found=true; founds=smod;}
          }
        }
        SetValue(parms->Strings[1],founds);
      }
      delete parms;
    }


    else if (cmd.SubString(1,14)=="--CloseProject")
    { bool res=ToolServices->CloseProject();
      SetValue(arg,bval(res));
      ProjectValid=!res;
    }


    else if (cmd.SubString(1,15)=="--NotAutoCreate")
    { NotAutoCreate(arg);
    }


    else if (cmd.SubString(1,18)=="--EnsureUniqueName")
    { TStringList *parms=new TStringList(); FromCommaText(parms,arg);
      if (parms->Count!=3) err("EnsureUniqueNames: expecting form,unit,dir but got "+arg);
      else
      { AnsiString keyf=parms->Strings[0], keyu=parms->Strings[1], keyd=parms->Strings[2];
        AnsiString fn=GetValue(keyf,NULL), un=GetValue(keyu,NULL), dir=GetValue(keyd,NULL);
        EnsureUniqueName(&fn,&un,&dir);
        SetValue(keyf,fn); SetValue(keyu,un); SetValue(keyd,dir);
      }
    }




    else if (cmd.SubString(1,6)=="--Icon" && ci!=NULL)
    { TComponent *c=(TComponent*)(ci->GetComponentHandle());
      TImage *image=dynamic_cast<TImage*>(c); TIcon *src=new TIcon(); bool okay=true;
      if (okay && image==NULL) {okay=false;err("Component is not a TImage");}
      if (okay && arg.Length()==0) {arg=" ";}
      if (okay)
      { if (arg[1]!='*') {try {src->LoadFromFile(arg);} catch (...) {okay=false;}}
        else
        { HICON hIcon=LoadIcon(HInstance,arg.SubString(2,arg.Length()-1).c_str());
          if (hIcon==NULL) okay=false;
          else {HICON hold=src->ReleaseHandle();src->Handle=hIcon;DestroyIcon(hold);}
        }
        if (!okay) err("Icon resource not found. Use one of *SCRPLUS,*BCB,*SCRHOTS,*SCRICON1, 2 or 3 or a filename");
      }
      if (okay) image->Picture->Icon->Assign(src);
      delete src;
    }


    else if (cmd.SubString(1,8)=="--Bitmap" && ci!=NULL)
    { TComponent *c=(TComponent*)(ci->GetComponentHandle());
      TImage *image=dynamic_cast<TImage*>(c); Graphics::TBitmap *src=new Graphics::TBitmap(); bool okay=true;
      if (okay && image==NULL) {okay=false;err("Component is not a TImage");}
      if (okay && arg.Length()==0) {arg=" ";}
      if (okay)
      { try
        { if (arg[1]=='*') src->LoadFromResourceName((int)HInstance,arg.SubString(2,arg.Length()-1));
          else src->LoadFromFile(arg);
        } catch (...) {okay=false;}
        if (!okay) err("Icon resource not found. Use *SCRPLUS or a filename");
      }
      if (okay) image->Picture->Bitmap->Assign(src);
      delete src;
    }


    else if (cmd.SubString(1,13)=="--IsFormValid")
    { SetValue(arg,bval(fi!=NULL));
    }
    else if (cmd.SubString(1,18)=="--IsComponentValid")
    { SetValue(arg,bval(ci!=NULL));
    }
    else if (cmd.SubString(1,16)=="--IsProjectValid")
    { SetValue(arg,bval(ProjectValid));
    }


    else if (cmd.SubString(1,8)=="--SetVal")
    { TStringList *sl=new TStringList(); FromCommaText(sl,arg);
      if (sl->Count!=2) err("Bad SetVal command");
      else SetValue(sl->Strings[0],sl->Strings[1]);
      delete sl;
    }


    else if (cmd.SubString(1,12)=="--MessageBox")
    { TStringList *parms=new TStringList(); FromCommaText(parms,arg);
      if (parms->Count==3) parms->Add("");
      if (parms->Count!=4) err("MessageBox: need 4 arguments "+arg);
      else
      { AnsiString body=parms->Strings[0];
        AnsiString title=parms->Strings[1]; if (title=="") title=Title;
        AnsiString key=parms->Strings[3];
        AnsiString btn=parms->Strings[2]; int flags; bool fok=true;
        if (btn=="MB_OK") flags=MB_OK;
        else if (btn=="MB_OKCANCEL") flags=MB_OKCANCEL;
        else if (btn=="MB_YESNO") flags=MB_YESNO;
        else if (btn=="MB_YESNOCANCEL") flags=MB_YESNOCANCEL;
        else fok=false;
        if (!fok) err("MessageBox incorect button argument "+btn);
        else
        { bool someleft;
          someleft=true; while (someleft) {int pos=body.Pos("\\r"); if (pos==0) someleft=false; else body=body.SubString(1,pos-1)+"\r"+body.SubString(pos+2,body.Length()-pos-1);}
          someleft=true; while (someleft) {int pos=body.Pos("\\n"); if (pos==0) someleft=false; else body=body.SubString(1,pos-1)+"\n"+body.SubString(pos+2,body.Length()-pos-1);}
          int res=Application->MessageBox(body.c_str(),title.c_str(),flags);
          if (key!="")
          { AnsiString val="";
            if (res==IDOK) val="IDOK"; else if (res==IDYES) val="IDYES";
            SetValue(key,val);
          }
        }
      }
      delete parms;
    }



// Here are some additional custom commands that seemed appropriate for
// my particular application. The relevant properties in these components
// do not have an 'ObjectInspector' interface: they can only be used
// with their own custom property editor, which brings up a dialog, doesn't
// work. That's why I've had to use this this horrible approach.

/*
    else if (cmd.SubString(1,13)=="--AddIntRange")
    { TStringList *parms=new TStringList(); FromCommaText(parms,arg);
      bool okay=true;
      if (parms->Count!=4) {err("Badly formed range: need (Caption,min,def,max) not "+arg);okay=false;}
      int min,def,max;
      if (okay)
      { try {min=parms->Strings[1].ToInt(); def=parms->Strings[2].ToInt(); max=parms->Strings[3].ToInt();}
        catch (EConvertError &e) {err("Bad range arguments "+arg);okay=false;}
      }
      if (okay && ci==NULL) {err("Can't add range: current component is NULL");okay=false;}
      TComponent *c; TScrVCustomInteger *v;
      if (okay)
      { c=(TComponent*)ci->GetComponentHandle();
        v=dynamic_cast<TScrVCustomInteger*>(c);
        if (v==NULL) {err("Current component is not an Integer value!");okay=false;}
      }
      if (okay)
      { TScrVIntegerRange *r=(TScrVIntegerRange*)v->Ranges->Add();
        r->Caption=parms->Strings[0];
        r->Min=min; r->Def=def;   r->Max=max;
      }
      delete parms;
    }


    else if (cmd.SubString(1,15)=="--AddIndexRange")
    { TStringList *parms=new TStringList(); FromCommaText(parms,arg);
      bool okay=true;
      if (parms->Count!=4) {err("Badly formed range: need (Caption,min,def,max) not "+arg);okay=false;}
      int min,def,max;
      if (okay)
      { try {min=parms->Strings[1].ToInt(); def=parms->Strings[2].ToInt(); max=parms->Strings[3].ToInt();}
        catch (EConvertError &e) {err("Bad range arguments "+arg);okay=false;}
      }
      if (okay && ci==NULL) {err("Can't add range: current component is NULL");okay=false;}
      TComponent *c; TScrVCustomIndex *v;
      if (okay)
      { c=(TComponent*)ci->GetComponentHandle();
        v=dynamic_cast<TScrVCustomIndex*>(c);
        if (v==NULL) {err("Current component is not an Integer value!");okay=false;}
      }
      if (okay)
      { TScrVIntegerRange *r=(TScrVIntegerRange*)v->Ranges->Add();
        r->Caption=parms->Strings[0];
        r->Min=min; r->Def=def;   r->Max=max;
      }
      delete parms;
    }


    else if (cmd.SubString(1,16)=="--AddDoubleRange")
    { TStringList *parms=new TStringList(); FromCommaText(parms,arg);
      bool okay=true;
      if (parms->Count!=4) {err("Badly formed range: need (Caption,min,def,max) not "+arg);okay=false;}
      double min,def,max;
      if (okay)
      { try {min=parms->Strings[1].ToDouble(); def=parms->Strings[2].ToDouble(); max=parms->Strings[3].ToDouble();}
        catch (EConvertError &e) {err("Bad range arguments "+arg);okay=false;}
      }
      if (okay && ci==NULL) {err("Can't add range: current component is NULL");okay=false;}
      TComponent *c; TScrVCustomDouble *v;
      if (okay)
      { c=(TComponent*)ci->GetComponentHandle();
        v=dynamic_cast<TScrVCustomDouble*>(c);
        if (v==NULL) {err("Current component is not an Integer value!");okay=false;}
      }
      if (okay)
      { TScrVDoubleRange *r=(TScrVDoubleRange*)v->Ranges->Add();
        r->Caption=parms->Strings[0];
        r->Min=min; r->Def=def;   r->Max=max;
      }
      delete parms;
    }
*/


    else if (cmd.SubString(1,9)=="--GetVals")
    { TStringList *skeys=new TStringList(); FromCommaText(skeys,arg);
      TStringList *svals=new TStringList();
      for (int i=0; i<skeys->Count; ++i)
      { AnsiString key=skeys->Strings[i];
        AnsiString val; // We'll initialise all new variables to empty
        if (nUserKeys->IndexOf(key)==-1) {nUserKeys->Add(key);nUserVals->Add("");val="";}
        else val=GetValue(key,NULL);
        svals->Add(val);
      }
      TCodeGenGetValuesForm *f=new TCodeGenGetValuesForm(this);
      f->Execute(skeys,svals);
      for (int i=0; i<skeys->Count; ++i)
      { int pu=nUserKeys->IndexOf(skeys->Strings[i]);
        if (pu!=-1) nUserVals->Strings[pu]=svals->Strings[i];
      }
      delete svals;
      delete skeys;
    }


    else if (cmd.SubString(1,15)=="--CreateProject")
    { TAutoProjectCreator *creator=new TAutoProjectCreator(&GetProjectSource,&err);
      TStringList *sargs=new TStringList(); FromCommaText(sargs,arg);
      bool okay=true; AnsiString nFlags="",nCode="";
      if (sargs->Count!=4) {okay=false;err("Bad arguments to CreateProject. Need filename,optionname,code+,flags not "+arg);}
      else
      { creator->nFileName=sargs->Strings[0].Trim();
        creator->nOptionName=sargs->Strings[1].Trim();
        creator->bExisting=false;
        nCode=sargs->Strings[2].Trim();
        nFlags=sargs->Strings[3].Trim();
      }
      delete sargs;
      if (okay)
      { TCreateProjectFlags mf;
        if (nFlags.Pos("cpCustom")!=0) mf << cpCustom;
        if (nFlags.Pos("cpApplication")!=0) mf << cpApplication;
        if (nFlags.Pos("cpLibrary")!=0) mf << cpLibrary;
        if (nFlags.Pos("cpCanShowSource")!=0) mf << cpCanShowSource;
        if (nFlags.Pos("cpExisting")!=0) {mf << cpExisting; creator->bExisting=true;}
        if (nFlags.Pos("cpConsole")!=0) mf << cpConsole;
        creator->cpFlags = mf;
        nCreateCode->Clear();
        bool donecode=false;
        while (!donecode)
        { int plus=nCode.Pos("+"); int minus=nCode.Pos("-");
          if (plus==0 && minus==0) donecode=true;
          else
          { int pos; if (plus==0) pos=minus; else if (minus==0) pos=plus;
            else {pos=plus; if (minus<pos) pos=minus;}
            nCreateCode->Add(nCode.SubString(1,pos)); nCode=nCode.SubString(pos+1,nCode.Length()-pos);
          }
        }
      }
      if (fi!=NULL) fi->Release(); fi=NULL;
      if (ci!=NULL) ci->Release(); ci=NULL;
      Designer=NULL; ProjectValid=false;
      if (okay)
      { bool res=creator->Execute();
        if (res) ProjectValid=true;
      }
      nCreateCode->Clear();
      delete creator;
    }


    else if (cmd.SubString(1,10)=="--SaveFile")
    { TStringList *sargs=new TStringList(); FromCommaText(sargs,arg);
      bool okay=true; AnsiString nFile="", nCode="";
      if (sargs->Count!=4) {okay=false;err("Bad arguments to SaveFile. Need Dir,Unit,Suffix,Code not "+arg);}
      else
      { nFile=sargs->Strings[0].Trim()+sargs->Strings[1].Trim()+sargs->Strings[2].Trim();
        nCode=sargs->Strings[3].Trim();
      }
      delete sargs;
      if (okay)
      { nCreateCode->Clear();
        bool donecode=false;
        while (!donecode)
        { int plus=nCode.Pos("+"); int minus=nCode.Pos("-");
          if (plus==0 && minus==0) donecode=true;
          else
          { int pos; if (plus==0) pos=minus; else if (minus==0) pos=plus;
            else {pos=plus; if (minus<pos) pos=minus;}
            nCreateCode->Add(nCode.SubString(1,pos)); nCode=nCode.SubString(pos+1,nCode.Length()-pos);
          }
        }
      }
      if (okay)
      { bool os=xScript; xScript=false;
        AnsiString s=CodeGenParse(MacroStream,GetValue,err);
        xScript=os;
        void*data=s.c_str(); DWORD size=s.Length();
        HANDLE hFile=CreateFile(nFile.c_str(),GENERIC_WRITE,0,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
        DWORD writ; WriteFile(hFile,data,size,&writ,NULL);
        CloseHandle(hFile);
        if (writ!=size) err("Error saving file "+nFile);
      }
      nCreateCode->Clear();
    }



    else if (cmd.SubString(1,12)=="--CreateFile")
    { TAutoFileCreator *creator=new TAutoFileCreator(&GetModuleSource,&err);
      TStringList *sargs=new TStringList(); FromCommaText(sargs,arg);
      bool okay=true; AnsiString nFlags="", nCode="";
      if (sargs->Count!=5) {okay=false;err("Bad arguments to CreateFile. Need Unit,Suffix,Dir,Code,Flags not "+arg);}
      else
      { creator->nUnit=sargs->Strings[0].Trim();
        creator->nSuffix=sargs->Strings[1].Trim();
        creator->nDir=sargs->Strings[2].Trim();
        nCode=sargs->Strings[3].Trim();
        nFlags=sargs->Strings[4].Trim();
      }
      delete sargs;
      if (okay)
      { TCreateModuleFlags mf;
        if (nFlags.Pos("cmAddToProject")!=0) mf << cmAddToProject;
        if (nFlags.Pos("cmMainForm")!=0) mf << cmMainForm;
        if (nFlags.Pos("cmMarkModified")!=0) mf << cmMarkModified;
        if (nFlags.Pos("cmShowForm")!=0) mf << cmShowForm;
        if (nFlags.Pos("cmShowSource")!=0) mf << cmShowSource;
        if (nFlags.Pos("cmUnNamed")!=0) mf << cmUnNamed;
        if (nFlags.Pos("bExisting")!=0) creator->bExisting=true;
        creator->cmFlags = mf;
        nCreateCode->Clear();
        bool donecode=false;
        while (!donecode)
        { int plus=nCode.Pos("+"); int minus=nCode.Pos("-");
          if (plus==0 && minus==0) donecode=true;
          else
          { int pos; if (plus==0) pos=minus; else if (minus==0) pos=plus;
            else {pos=plus; if (minus<pos) pos=minus;}
            nCreateCode->Add(nCode.SubString(1,pos)); nCode=nCode.SubString(pos+1,nCode.Length()-pos);
          }
        }
      }
      if (fi!=NULL) fi->Release(); fi=NULL;
      if (ci!=NULL) ci->Release(); ci=NULL;
      Designer=NULL;
      if (okay) creator->Execute(&fi);
      if (fi!=NULL) ci=fi->GetFormComponent();
      nCreateCode->Clear();
      delete creator;
      if (fi!=NULL) Designer=GetFormDesigner(fi);
    }


    else if (cmd.SubString(1,12)=="--CreateForm")
    { TAutoModuleCreator *creator=new TAutoModuleCreator(&GetModuleSource,&err);
      TStringList *sargs=new TStringList(); FromCommaText(sargs,arg);
      bool okay=true; AnsiString nFlags="", nCode="";
      if (sargs->Count!=6) {okay=false;err("Bad arguments to CreateForm. Need Ancestor,Form,Unit,Dir,Code,Flags. Not "+arg);}
      else
      { creator->nFormAncestor=sargs->Strings[0].Trim();
        creator->nForm=sargs->Strings[1].Trim();
        creator->nUnit=sargs->Strings[2].Trim();
        creator->nDir=sargs->Strings[3].Trim();
        nFlags=sargs->Strings[5].Trim();
        creator->bExisting=false;
        nCode=sargs->Strings[4].Trim();
      }
      delete sargs;
      if (okay)
      { TCreateModuleFlags mf;
        if (nFlags.Pos("cmAddToProject")!=0) mf << cmAddToProject;
        if (nFlags.Pos("cmMainForm")!=0) mf << cmMainForm;
        if (nFlags.Pos("cmMarkModified")!=0) mf << cmMarkModified;
        if (nFlags.Pos("cmShowForm")!=0) mf << cmShowForm;
        if (nFlags.Pos("cmShowSource")!=0) mf << cmShowSource;
        if (nFlags.Pos("cmUnNamed")!=0) mf << cmUnNamed;
        if (nFlags.Pos("bExisting")!=0) creator->bExisting=true;
        creator->cmFlags = mf;
        nCreateCode->Clear();
        bool donecode=false;
        while (!donecode)
        { int plus=nCode.Pos("+"); int minus=nCode.Pos("-");
          if (plus==0 && minus==0) donecode=true;
          else
          { int pos; if (plus==0) pos=minus; else if (minus==0) pos=plus;
            else {pos=plus; if (minus<pos) pos=minus;}
            nCreateCode->Add(nCode.SubString(1,pos)); nCode=nCode.SubString(pos+1,nCode.Length()-pos);
          }
        }
      }
      if (fi!=NULL) fi->Release(); fi=NULL;
      if (ci!=NULL) ci->Release(); ci=NULL;
      Designer=NULL;
      if (okay) creator->Execute(&fi);
      if (fi!=NULL) ci=fi->GetFormComponent();
      nCreateCode->Clear();
      delete creator;
      if (fi!=NULL) Designer=GetFormDesigner(fi);
    }


    else if (cmd.SubString(1,17)=="--CreateComponent")
    { TStringList *sargs=new TStringList(); FromCommaText(sargs,arg);
      AnsiString TypeName=sargs->Strings[0].Trim();
      AnsiString Container=sargs->Strings[1].Trim();
      TIComponentInterface *cci=NULL;
      if (Container=="it")
      { if (ci==NULL) err("CreateComponent bad parent: it is null");
        else {cci=ci; cci->AddRef();} // the AddRef is because it wears two hats
      }
      else
      { if (Container!="" && fi!=NULL) cci=fi->FindComponent(Container);
      }
      bool okay=false; int left,top,width,height;
      try
      { left=sargs->Strings[2].ToInt();
        top=sargs->Strings[3].ToInt();
        width=sargs->Strings[4].ToInt();
        height=sargs->Strings[5].ToInt();
        okay=true;
      }
      catch (...)
      { err("Badly formed CreateComponent "+arg);
      }
      delete sargs;
      if (okay && fi!=NULL)
      { if (ci!=NULL) ci->Release(); ci=NULL;
        ci=fi->CreateComponent(cci,TypeName,left,top,width,height);
      }
      if (cci!=NULL) cci->Release();
    }


    else if (cmd.SubString(1,15)=="--FindComponent")
    { if (ci!=NULL) ci->Release(); ci=NULL;
      if (fi!=NULL) ci=fi->FindComponent(arg);
    }


    else if (cmd.SubString(1,19)=="--FindFormComponent")
    { if (ci!=NULL) ci->Release(); ci=NULL;
      if (fi!=NULL) ci=fi->GetFormComponent();
    }


    else if (cmd.SubString(1,17)=="--GetSubComponent")
    { TIComponentInterface *newci=NULL;
      int index=-1;
      try {index=arg.ToInt();}
      catch (EConvertError &e) {err("GetSubComponent bad index "+arg);}
      if (ci==NULL) err("GetSubComponent: but currently NULL");
      if (ci!=NULL && index!=-1)
      { int i=ci->GetComponentCount();
        if (index>=i) err("GetSubComponent out of bounds: only "+AnsiString(i)+" not "+arg+" subcomponents");
        else newci=ci->GetComponent(index);
      }
      if (ci!=NULL) ci->Release(); ci=NULL;
      ci=newci;
    }


    else if (cmd.SubString(1,13)=="--OpenProject")
    { if (fi!=NULL) fi->Release(); fi=NULL;
      if (ci!=NULL) ci->Release(); ci=NULL;
      Designer=NULL;
      bool res=ToolServices->OpenProject(arg);
      ProjectValid=res;
    }


    else if (cmd.SubString(1,10)=="--OpenForm")
    { if (fi!=NULL) fi->Release(); fi=NULL;
      if (ci!=NULL) ci->Release(); ci=NULL;
      Designer=NULL;
      TIModuleInterface *mi=GetFormModuleInterfaceEx(arg,gmiOpenFormIfNecessary);
      if (mi!=NULL)
      { fi=mi->GetFormInterface();
        if (fi!=NULL) {ci=fi->GetFormComponent(); Designer=GetFormDesigner(fi);}
        mi->Release();
      }
    }


    else if (cmd.SubString(1,9)=="--GetProp")
    { TStringList *sl=new TStringList(); FromCommaText(sl,arg);
      if (sl->Count!=2) err("GetProp bad arguments: need prop,key not "+arg);
      else
      { AnsiString val="", prop=sl->Strings[0], key=sl->Strings[1];
        if (ci!=NULL && Designer!=NULL) val=ScriptGetProperty(ci,Designer,prop);
        SetValue(key,val);
      }
      delete sl;
    }


    else if (op=='=') // a set-property thing
    { AnsiString prop=cmd.Trim(), val=arg.Trim();
      if (val.Length()>=1 && val[1]=='\"') val=val.SubString(2,val.Length()-1);
      if (val.Length()>=1 && val[val.Length()]=='\"') val=val.SubString(1,val.Length()-1);
      if (ci!=NULL && Designer!=NULL) ScriptSetProperty(ci,Designer,prop,val);
    }


    else if (op==':') // invoking a command from the drop-down menu
    { AnsiString val=arg.Trim();
      if (ci!=NULL && Designer!=NULL) ScriptSetComponent(ci,Designer,val);
    }

    //
    gotmore=mac->GetNextLine(&CurrentLine);
  }

  if (fi!=NULL) fi->Release();
  if (ci!=NULL) ci->Release();
  delete mac;
  delete MacroStream; MacroStream=NULL;
}


TFormDesigner* __fastcall TCodeGenerator::GetFormDesigner(TIFormInterface *fi)
{ TIComponentInterface *fci=fi->GetFormComponent();
  AnsiString name=""; bool res=false;
  TPropertyType pt=fci->GetPropTypeByName("Name");
  if (pt==ptString || pt==ptLString || pt==ptLWString) res=fci->GetPropValueByName("Name",&name);
  fci->Release();
  if (!res) return NULL;
  TIForm* ifi=CompLib->FindForm(name);
  if (ifi==NULL) return NULL;
  TFormDesigner *des=ifi->Designer;
  return des;
}


 