#include <vcl\vcl.h>
#pragma hdrstop
#include <vcl\registry.hpp>
#include <vcl\clipbrd.hpp>

#include "codemac_edit.h"
#include "codemac_about.h"
#include "codeexp_codegen.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "ColMemo"
#pragma resource "*.dfm"
TEditForm *EditForm;
//---------------------------------------------------------------------------
__fastcall TEditForm::TEditForm(TComponent* Owner)
    : TForm(Owner)
{ MacDirty=false; KeysCount=0;
  FFileName="not"; FileName=""; KeysName="";
  FOutputDirty=false;
  TRegistry *reg=new TRegistry();
  reg->OpenKey("Software\\Lu\\Codemac",true);
  try
  { AnsiString keyfn=reg->ReadString("fnkeys");
    if (FileExists(keyfn)) {KeysMemo->Lines->LoadFromFile(keyfn);KeysCount=KeysMemo->Lines->Count;KeysMemo->ClearUndo();KeysName=keyfn;}
  } catch (...) {}
  if (ParamCount()>=1 && ParamStr(1)=="/new")
  {
  }
  else if (ParamCount()>=1)
  { AnsiString macfn=ParamStr(1);
    if (!FileExists(macfn)) macfn=macfn+".mac";
    if (FileExists(macfn)) {MacMemo->Lines->LoadFromFile(macfn);MacMemo->ClearUndo();FileName=macfn;MacDirty=false;}
  }
  else
  { try
    { AnsiString macfn=reg->ReadString("fnmac");
      if (FileExists(macfn)) {MacMemo->Lines->LoadFromFile(macfn);MacMemo->ClearUndo();FileName=macfn;MacDirty=false;}
    } catch (...) {}
  }
  try
  { int left=reg->ReadInteger("left");
    int top=reg->ReadInteger("top");
    int width=reg->ReadInteger("width");
    int height=reg->ReadInteger("height");
    int keyswidth=reg->ReadInteger("keyswidth");
    int outwidth=reg->ReadInteger("outwidth");
    SetBounds(left,top,width,height);
    KeysMemo->Width=keyswidth;
    OutputMemo->Width=outwidth;
  } catch (...) {}
  try
  { int ikeys=reg->ReadInteger("vkeys"); bool keys=(ikeys!=0);
    int ioutp=reg->ReadInteger("voutp"); bool outp=(ioutp!=0);
    Keys1->Checked=keys; Splitter1->Visible=keys; KeysMemo->Visible=keys;
    Output1->Checked=outp; Splitter2->Visible=outp; OutputMemo->Visible=outp;
  } catch (...) {}
  delete reg;
  Realign();
}
void __fastcall TEditForm::SetFileName(AnsiString v)
{ if (v==FileName) return;
  FFileName=v; AnsiString s;
  if (FileName=="") s="Untitled"; else s=ChangeFileExt(ExtractFileName(FileName),"");
  s=s+" - "+ChangeFileExt(ExtractFileName(Application->ExeName),"");
  Caption=s;
  Application->Title=s;
}
//---------------------------------------------------------------------------

void __fastcall TEditForm::TouchRC()
{ if (FileName=="") return;
  AnsiString dir=ExtractFilePath(FileName); if (dir=="") return;
  AnsiString fn=ExtractFileName(FileName).LowerCase(); if (fn=="") return;
  AnsiString search=dir+"*.rc";
  WIN32_FIND_DATA fd;
  HANDLE hFind=FindFirstFile(search.c_str(),&fd);
  bool res=(hFind!=INVALID_HANDLE_VALUE);
  while (res)
  { AnsiString rc=dir+AnsiString(fd.cFileName);
    TStringList *s=new TStringList(); s->LoadFromFile(rc);
    int pos=s->Text.LowerCase().Pos(fn);
    delete s;
    if (pos!=0)
    { FILETIME time; SYSTEMTIME syst;
      GetSystemTime(&syst); SystemTimeToFileTime(&syst,&time);
      HANDLE hf=CreateFile(rc.c_str(),GENERIC_READ|GENERIC_WRITE,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,OPEN_EXISTING,0,NULL);
      SetFileTime(hf,NULL,&time,&time);
      CloseHandle(hf);
    }
    res=FindNextFile(hFind,&fd);
  }
  if (hFind!=INVALID_HANDLE_VALUE) FindClose(hFind);
}
//---------------------------------------------------------------------------

void __fastcall TEditForm::Output1Click(TObject *Sender)
{ Output1->Checked=!Output1->Checked;
  Splitter2->Visible=Output1->Checked;
  OutputMemo->Visible=Output1->Checked;
  Realign();
  if (Output1->Checked && FOutputDirty) OutputRender();
  if (!MacMemo->Focused()) MacMemo->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TEditForm::Keys1Click(TObject *Sender)
{ Keys1->Checked=!Keys1->Checked;
  Splitter1->Visible=Keys1->Checked;
  KeysMemo->Visible=Keys1->Checked;
  Realign();
  TWinControl *focus; if (Keys1->Checked) focus=KeysMemo; else focus=MacMemo;
  if (!focus->Focused()) focus->SetFocus();
}
//---------------------------------------------------------------------------
bool __fastcall TEditForm::CheckCloseKeys()
{ int count=KeysMemo->Lines->Count;
  if (count==KeysCount) return true;
  AnsiString s; if (KeysName=="") s="Keys"; else s=ExtractFileName(KeysName);
  s=s+" have changed: save changes?";
  int ires=Application->MessageBox(s.c_str(),"Close",MB_YESNOCANCEL);
  if (ires==IDCANCEL) return false;
  if (ires==IDNO) return true;
  if (KeysName=="")
  { SaveKeysDialog->FileName=KeysName;
    SaveKeysDialog->InitialDir=ExtractFilePath(KeysName);
    bool bres=SaveKeysDialog->Execute();
    if (!bres) return false;
    KeysName=SaveKeysDialog->FileName;
  }
  KeysMemo->Lines->SaveToFile(KeysName);
  KeysMemo->ClearUndo();
  KeysCount=KeysMemo->Lines->Count;
  return true;
}

bool __fastcall TEditForm::CheckCloseMac()
{ if (!MacDirty) return true;
  AnsiString s; if (FileName=="") s="Document"; else s=ExtractFileName(FileName);
  s=s+" has changed: save changes?";
  int ires=Application->MessageBox(s.c_str(),"Close",MB_YESNOCANCEL);
  if (ires==IDCANCEL) return false;
  if (ires==IDNO) return true;
  if (FileName=="")
  { SaveMacDialog->FileName=FileName;
    SaveMacDialog->InitialDir=ExtractFilePath(FileName);
    bool bres=SaveMacDialog->Execute();
    if (!bres) return false;
    FileName=SaveMacDialog->FileName;
  }
  MacMemo->Lines->SaveToFile(FileName);
  MacMemo->ClearUndo();
  MacDirty=false;
  TouchRC();
  return true;
}

void __fastcall TEditForm::New1Click(TObject *Sender)
{ bool bres=CheckCloseMac();
  if (!bres) return;
  MacMemo->Clear();
  FileName="";
  MacDirty=false;
  TRegistry *reg=new TRegistry(); reg->OpenKey("Software\\Lu\\Codemac",true);
  reg->WriteString("fnmac",FileName); delete reg;
}
//---------------------------------------------------------------------------

void __fastcall TEditForm::MacMemoChange(TObject *Sender)
{ MacDirty=true;
  OutputDirty();
}
//---------------------------------------------------------------------------

void __fastcall TEditForm::KeysMemoChange(TObject *Sender)
{ OutputDirty();
}
//---------------------------------------------------------------------------

void __fastcall TEditForm::Open1Click(TObject *Sender)
{ bool bres=CheckCloseMac();
  if (!bres) return;
  OpenMacDialog->FileName="";
  OpenMacDialog->InitialDir=ExtractFilePath(FileName);
  bres=OpenMacDialog->Execute();
  if (!bres) return;
  MacMemo->Lines->LoadFromFile(OpenMacDialog->FileName);
  MacMemo->ClearUndo();
  FileName=OpenMacDialog->FileName;
  MacDirty=false;
  TRegistry *reg=new TRegistry(); reg->OpenKey("Software\\Lu\\Codemac",true);
  reg->WriteString("fnmac",FileName); delete reg;
}
//---------------------------------------------------------------------------

void __fastcall TEditForm::Save1Click(TObject *Sender)
{ if (FileName=="") {SaveAs1Click(Sender);return;}
  MacMemo->Lines->SaveToFile(FileName);
  MacMemo->ClearUndo();
  MacDirty=false;
  TRegistry *reg=new TRegistry(); reg->OpenKey("Software\\Lu\\Codemac",true);
  reg->WriteString("fnmac",FileName); delete reg;
  TouchRC();
}
//---------------------------------------------------------------------------

void __fastcall TEditForm::SaveAs1Click(TObject *Sender)
{ SaveMacDialog->FileName=FileName;
  SaveMacDialog->InitialDir=ExtractFilePath(FileName);
  bool bres=SaveMacDialog->Execute();
  if (!bres) return;
  FileName=SaveMacDialog->FileName;
  MacMemo->Lines->SaveToFile(FileName);
  MacMemo->ClearUndo();
  MacDirty=false;
  TRegistry *reg=new TRegistry(); reg->OpenKey("Software\\Lu\\Codemac",true);
  reg->WriteString("fnmac",FileName); delete reg;
  TouchRC();
}
//---------------------------------------------------------------------------

void __fastcall TEditForm::Exit1Click(TObject *Sender)
{ Close();
}
//---------------------------------------------------------------------------

void __fastcall TEditForm::Openkeys1Click(TObject *Sender)
{ bool bres=CheckCloseKeys();
  if (!bres) return;
  OpenKeysDialog->FileName="";
  OpenKeysDialog->InitialDir=ExtractFilePath(KeysName);
  bres=OpenKeysDialog->Execute();
  if (!bres) return;
  AnsiString fn=OpenKeysDialog->FileName;
  KeysName=fn;
  KeysMemo->Lines->LoadFromFile(fn);
  KeysMemo->ClearUndo();
  KeysCount=KeysMemo->Lines->Count;
  TRegistry *reg=new TRegistry(); reg->OpenKey("Software\\Lu\\Codemac",true);
  reg->WriteString("fnkeys",fn); delete reg;
}
//---------------------------------------------------------------------------

void __fastcall TEditForm::Savekeys1Click(TObject *Sender)
{ if (KeysName=="") {Savekeysas1Click(Sender);return;}
  KeysMemo->Lines->SaveToFile(KeysName);
  KeysMemo->ClearUndo();
  KeysCount=KeysMemo->Lines->Count;
  TRegistry *reg=new TRegistry(); reg->OpenKey("Software\\Lu\\Codemac",true);
  reg->WriteString("fnkeys",KeysName); delete reg;
}
void __fastcall TEditForm::Savekeysas1Click(TObject *Sender)
{ SaveKeysDialog->FileName=KeysName;
  SaveKeysDialog->InitialDir=ExtractFilePath(KeysName);
  bool bres=SaveKeysDialog->Execute();
  if (!bres) return;
  KeysName=SaveKeysDialog->FileName;
  KeysMemo->Lines->SaveToFile(KeysName);
  KeysMemo->ClearUndo();
  KeysCount=KeysMemo->Lines->Count;
  TRegistry *reg=new TRegistry(); reg->OpenKey("Software\\Lu\\Codemac",true);
  reg->WriteString("fnkeys",KeysName); delete reg;
}

//---------------------------------------------------------------------------
AnsiString __fastcall TEditForm::GetValueFunc(const AnsiString key,bool *found)
{ if (found!=NULL) *found=true;
  AnsiString match=key+"=";
  int matchlen=match.Length();
  for (int i=0; i<KeysMemo->Lines->Count; i++)
  { if (KeysMemo->Lines->Strings[i].SubString(1,matchlen)==match)
    { AnsiString s=KeysMemo->Lines->Strings[i];
      return s.SubString(matchlen+1,s.Length()-matchlen);
    }
  }
  if (found!=NULL) *found=false; return "";
}
void __fastcall TEditForm::OutputDirty()
{ FOutputDirty=true;
  if (!OutputMemo->Visible) return;
  OutputRender();
}
void __fastcall TEditForm::OutputRender()
{ FOutputDirty=false;
  int line=::SendMessage(OutputMemo->Handle,EM_GETFIRSTVISIBLELINE,0,0);
  int ss=OutputMemo->SelStart;
  int sl=OutputMemo->SelLength;
  TStringStream *sin=new TStringStream(MacMemo->Lines->Text);
  OutputMemo->Lines->Text=CodeGenParse(sin,GetValueFunc,NULL);
  delete sin;
  OutputMemo->SelStart=ss;
  OutputMemo->SelLength=sl;
  int nl=::SendMessage(OutputMemo->Handle,EM_GETFIRSTVISIBLELINE,0,0);
  int diff=line-nl;
  ::SendMessage(OutputMemo->Handle,EM_LINESCROLL,0,diff);
}


void __fastcall TEditForm::FormClose(TObject *Sender, TCloseAction &Action)
{ TRegistry *reg=new TRegistry();
  reg->OpenKey("Software\\Lu\\Codemac",true);
  reg->WriteInteger("left",Left);
  reg->WriteInteger("top",Top);
  reg->WriteInteger("width",Width);
  reg->WriteInteger("height",Height);
  reg->WriteInteger("keyswidth",KeysMemo->Width);
  reg->WriteInteger("outwidth",OutputMemo->Width);
  reg->WriteInteger("vkeys",Keys1->Checked?1:0);
  reg->WriteInteger("voutp",Output1->Checked?1:0);
  delete reg;
}
//---------------------------------------------------------------------------






void __fastcall TEditForm::mCutClick(TObject *Sender)
{ TMemo *memo=dynamic_cast<TMemo*>(ActiveControl); if (memo==NULL) return;
  memo->CutToClipboard();
}
//---------------------------------------------------------------------------

void __fastcall TEditForm::mCopyClick(TObject *Sender)
{ TMemo *memo=dynamic_cast<TMemo*>(ActiveControl); if (memo==NULL) return;
  memo->CopyToClipboard();
}
//---------------------------------------------------------------------------

void __fastcall TEditForm::mPasteClick(TObject *Sender)
{ TMemo *memo=dynamic_cast<TMemo*>(ActiveControl); if (memo==NULL) return;
  memo->PasteFromClipboard();
}
//---------------------------------------------------------------------------

void __fastcall TEditForm::Edit1Click(TObject *Sender)
{ TMemo *memo=dynamic_cast<TMemo*>(ActiveControl);
  bool cancut= (memo==MacMemo || memo==KeysMemo);
  mCut->Enabled=cancut;
  mPaste->Enabled=cancut;
  mPaste->Enabled = (Clipboard()->AsText.Length()>0);
  mUndo->Enabled= (memo==NULL?false:memo->CanUndo);
}
//---------------------------------------------------------------------------




void __fastcall TEditForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{ CanClose=CheckCloseMac();
  if (!CanClose) return;
  CanClose=CheckCloseKeys();
}
//---------------------------------------------------------------------------

void __fastcall TEditForm::mUndoClick(TObject *Sender)
{ TMemo *memo=dynamic_cast<TMemo*>(ActiveControl); if (memo==NULL) return;
  memo->Undo();
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------

void __fastcall TEditForm::AboutClick(TObject *Sender)
{ AboutForm->Show();
}
//---------------------------------------------------------------------------

